# coding: utf-8
u"""Описания пользовательского интерфейса приложения логирования СМЭВ."""
from m3_ext.ui import all_components as ext
from objectpack.ui import BaseListWindow
from objectpack.ui import ModelEditWindow
from objectpack.ui import anchor100

from educommon.ws_log.models import SmevLog, SmevProvider


class SmevLogEditWindow(
    ModelEditWindow.fabricate(
        SmevLog, field_list=['request', 'response', 'error'])
):
    u"""Окно редактирования логов СМЭВ."""

    def _do_layout(self):
        u"""Расположение компонентов окна."""
        super(SmevLogEditWindow, self)._do_layout()
        map(anchor100, self.form.items)

    def set_params(self, params):
        u"""Настройка окна."""
        super(SmevLogEditWindow, self).set_params(params)
        self.height, self.width = 800, 800

        self.make_read_only()

        for field in self.form.items:
            if isinstance(field, ext.ExtTextArea):
                field.height = 240


class SmevLogListWindow(BaseListWindow):
    u"""Окно списка логов СМЭВ."""

    def set_params(self, params):
        u"""Настройка окна."""
        super(SmevLogListWindow, self).set_params(params)
        self.maximized = True


class SmevProviderListWindow(BaseListWindow):

    u"""Окно списка поставщиков СМЭВ."""

    def set_params(self, params):
        super(SmevProviderListWindow, self).set_params(params)
        self.width = 1000


class SmevProviderEditWindow(ModelEditWindow):

    u"""Окно добавления/редактирования поставщиков СМЭВ."""

    model = SmevProvider

    def set_params(self, params):
        super(SmevProviderEditWindow, self).set_params(params)
        self.form.label_width = 200
        self.width = 500
